<?php namespace Anomaly\ThrottleSecurityCheckExtension;

use Anomaly\ThrottleSecurityCheckExtension\Command\ThrottleLogin;
use Anomaly\ThrottleSecurityCheckExtension\Command\ThrottleRequest;
use Anomaly\UsersModule\User\Contract\UserInterface;
use Anomaly\UsersModule\User\Security\SecurityCheckExtension;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class ThrottleSecurityCheckExtension
 *
 * @link          http://anomaly.is/streams-platform
 * @author        AnomalyLabs, Inc. <hello@anomaly.is>
 * @author        Ryan Thompson <ryan@anomaly.is>
 * @package       Anomaly\Streams\Addon\Extension\ThrottleSecurityCheckExtension
 */
class ThrottleSecurityCheckExtension extends SecurityCheckExtension
{

    /**
     * This extension provides a security check
     * for users that assures the user is not throttle.
     *
     * @var string
     */
    protected $provides = 'anomaly.module.users::security_check.throttle';

    /**
     * Check a login attempt.
     *
     * @return bool|Response
     */
    public function attempt()
    {
        return $this->dispatch(new ThrottleLogin());
    }

    /**
     * Check an HTTP request.
     *
     * @param UserInterface|null $user
     * @return bool|Response
     */
    public function check(UserInterface $user = null)
    {
        return true;
    }


}
